%global eclipse_base	%{_libdir}/eclipse
%global eclipse_dropins	%{_datadir}/eclipse/dropins
%global	install_loc	%{eclipse_dropins}/wtp-webservices

Name:		eclipse-wtp-webservices
Version:	3.4.0
Release:	5%{?dist}
Summary:	Tools for developing and interacting with Java Web services

Group:		Development/Tools
License:	EPL
URL:		http://www.eclipse.org/webtools/ws/

# tarball created with fetch-wtp-webservices-using-map.sh
Source0:	%{name}-R%{version}.tar.xz
Source1:	http://www.eclipse.org/legal/epl-v10.html

# build fails looking for old versions of javax.wsdl
Patch0:		%{name}-fix-javax.wsdl-version-in-manifests.patch
Patch1:		%{name}-rm-javax.wsdl-version-check-in-wsdl15-feature.patch

# Add unimplemented methods for javax.wsdl
Patch3:		%{name}-wsdl-unimplemented-methods.patch

# fix to work with fedora packaged xerces-j2 (more up-to-date)
Patch4:		%{name}-wsdl.validation-fix-for-xerces-j2-2.11.0.patch

# fails to find our version of javax.xml.soap, if version specified
#Patch5:		%{name}-rm-javaxxmlsoap-version-check.patch

# add org.eclipse.jst.ws.annotations.core
Patch6:		%{name}-jst.ws.annotations.core.patch

# Remove specific versioning from some bundles in
# org.eclipse.wst.ws_core.feature/feature.xml and rm javax.activation
Patch7:		%{name}-feature-versions.patch

# We link our own apache-commons-discovery jar into
# org.apache.commons.discovery/lib so need to change Bundle-ClassPath
Patch8:		%{name}-commons-discovery-manifest.patch

# Import xml-commons-apis org.w3c.dom stuff here
# openjdk provided one doesn't have everything that's needed
Patch9:	 	%{name}-org.w3c.dom.patch

BuildArch:	noarch

BuildRequires:	java-devel
BuildRequires:	jpackage-utils

BuildRequires:	ant >= 0:1.8.3-1
BuildRequires:	apache-commons-codec >= 1.6-2
BuildRequires:	apache-commons-discovery >= 0.5-3
BuildRequires:	apache-commons-logging >= 1.1.1-1
BuildRequires:	axis >= 0:1.4-16
BuildRequires:	geronimo-osgi-support >= 1.0
BuildRequires:	javamail >= 1.4.3-11
BuildRequires:	log4j >= 1.2.17-2
BuildRequires:	uddi4j >= 2.0.5-4
BuildRequires:	wsdl4j >= 0:1.6.2-5
BuildRequires:	wsil4j >= 1.0
BuildRequires:	xerces-j2 >= 2.11.0-7

BuildRequires:	eclipse-emf-core >= 2.8.0-0.22
BuildRequires:	eclipse-emf-sdk >= 2.8.0
BuildRequires:	eclipse-emf-xsd >= 2.8.0-0.7
BuildRequires:	eclipse-gef >= 3.8.0-0.3
BuildRequires:	eclipse-pde >= 1:4.2.0-0.22
BuildRequires:	eclipse-platform >= 1:4.2.0-0.22
BuildRequires:	eclipse-rcp >= 1:4.2.0-0.22
BuildRequires:	eclipse-swt >= 1:4.2.0-0.22
BuildRequires:	eclipse-wtp-common >= 3.4.0-0.1
BuildRequires:	eclipse-wtp-servertools >= 3.3.1-4
BuildRequires:	eclipse-wtp-sourceediting >= 3.4.0-0.1
BuildRequires:	icu4j-eclipse >= 1:4.4.2.2-11

Requires:	java
Requires:	jpackage-utils

Requires:	ant >= 0:1.8.3-1
Requires:	apache-commons-codec >= 1.6-2
Requires:	apache-commons-logging >= 0.5-3
Requires:	apache-commons-discovery >= 1.1.1-1
Requires:	axis >= 0:1.4-16
Requires:	geronimo-osgi-support
Requires:	javamail >= 1.4.3-11
Requires:	log4j >= 1.2.17-2
Requires:	uddi4j >= 2.0.5-4
Requires:	wsdl4j >= 0:1.6.2-5
Requires:	wsil4j >= 1.0
Requires:	xerces-j2 >= 2.11.0-7

Requires:	eclipse-emf-core >= 2.8.0-0.22
Requires:	eclipse-emf-sdk >= 2.8.0
Requires:	eclipse-emf-xsd >= 2.8.0-0.7
Requires:	eclipse-gef >= 3.8.0-0.3
Requires:	eclipse-platform >= 1:4.2.0-0.22
Requires:	eclipse-rcp >= 1:4.2.0-0.22
Requires:	eclipse-swt >= 1:4.2.0-0.22
Requires:	eclipse-wtp-common >= 3.4.0-0.1
Requires:	eclipse-wtp-servertools >= 3.3.1-4
Requires:	eclipse-wtp-sourceediting >= 3.4.0-0.1
Requires:	icu4j-eclipse >= 1:4.4.2.2-11

%description
The JST Web services component contains tools for developing and interacting
with Java Web services. 


%prep
%setup -q -n %{name}-R%{version}
cp %{SOURCE1} .

find . -type f -name *.jar -delete
find . -type f -name *.class -delete

#Orbit links
rm -rf orbit
mkdir orbit
pushd orbit
%{__ln_s} %{_javadir}/apache-commons-codec.jar
%{__ln_s} %{_javadir}/apache-commons-logging.jar
%{__ln_s} %{_javadir}/javamail/mail.jar
%{__ln_s} %{_javadir}/log4j.jar
%{__ln_s} %{_javadir}/uddi4j.jar
%{__ln_s} %{_javadir}/wsdl4j.jar
%{__ln_s} %{_javadir}/wsil4j.jar
popd

%patch0
%patch1
%patch3
%patch4
%patch6
%patch7
%patch8
%patch9

# Remove problematic org.eclipse.license stuff
find -name feature.xml -type f -exec sed -i -e 's/license-feature="org.eclipse.license"//g' {} \;

# Link Fedora jars into these weird eclipse wrapper bundles.
# These were removed before, but it turns out they're necessary : RHBZ 872806
pushd org.eclipse.orbit/org.apache.axis/lib/
 rm -f axis.jar axis-ant.jar
 %{__ln_s} %{_javadir}/axis/axis.jar
 %{__ln_s} %{_javadir}/axis/axis-ant.jar
popd
pushd org.eclipse.orbit/javax.xml.rpc/lib/
 rm -f jaxrpc.jar
 %{__ln_s} %{_javadir}/axis/jaxrpc.jar
popd
pushd org.eclipse.orbit/org.apache.commons.discovery/lib/
 rm -f commons-discovery-0.2.jar
 %{__ln_s} %{_javadir}/apache-commons-discovery.jar
popd
pushd org.eclipse.orbit/javax.xml.soap/lib/
  rm -f saaj.jar
  %{__ln_s} %{_javadir}/axis/saaj.jar
popd

%build
%{_bindir}/eclipse-pdebuild \
	-f org.eclipse.wst.ws_ui.feature \
	-d "xsd eclipse-wtp-common wtp-sourceediting emf emf-sdk gef \
	   org.eclipse.jst.server_ui.feature jem" \
	-o `pwd`/orbit

%install
install -d -m 755 %{buildroot}%{install_loc}

%{__unzip} -q -d %{buildroot}%{install_loc} \
	   build/rpmBuild/org.eclipse.wst.ws_ui.feature.zip

#Recreate symlinks for orbit dependencies
pushd %{buildroot}%{install_loc}/eclipse/plugins
rm -f javax.mail_*.jar
rm -f javax.wsdl_*.jar
rm -f javax.xml_*.jar
rm -f org.apache.commons.codec_*.jar
rm -f org.apache.commons.logging_*.jar
rm -f org.apache.log4j_*.jar
rm -f org.apache.xerces_*.jar
rm -f org.apache.xml.resolver_*.jar
rm -f org.apache.xml.serializer_*.jar

%{__ln_s} %{_javadir}/apache-commons-codec.jar
%{__ln_s} %{_javadir}/apache-commons-logging.jar
%{__ln_s} %{_javadir}/javamail/mail.jar
%{__ln_s} %{_javadir}/log4j.jar
%{__ln_s} %{_javadir}/uddi4j.jar
%{__ln_s} %{_javadir}/wsdl4j.jar
%{__ln_s} %{_javadir}/wsil4j.jar
%{__ln_s} %{_javadir}/xerces-j2.jar
%{__ln_s} %{_javadir}/xml-commons-apis.jar
%{__ln_s} %{_javadir}/xalan-j2-serializer.jar
%{__ln_s} %{_javadir}/xml-commons-resolver.jar
popd

pushd %{buildroot}%{install_loc}/eclipse/plugins/org.apache.axis_*/lib/
rm -f axis.jar
rm -f axis-ant.jar
%{__ln_s} %{_javadir}/axis/axis.jar
%{__ln_s} %{_javadir}/axis/axis-ant.jar
popd
pushd %{buildroot}%{install_loc}/eclipse/plugins/org.apache.commons.discovery_*/lib/
rm -f apache-commons-discovery.jar
%{__ln_s} %{_javadir}/apache-commons-discovery.jar
popd
pushd %{buildroot}%{install_loc}/eclipse/plugins/javax.xml.rpc_*/lib/
rm -f jaxrpc.jar
%{__ln_s} %{_javadir}/axis/jaxrpc.jar
popd
pushd %{buildroot}%{install_loc}/eclipse/plugins/javax.xml.soap_*/lib/
  rm -f saaj.jar
  %{__ln_s} %{_javadir}/axis/saaj.jar
popd

#remove duplicate features/plugins provided by other wtp packages
pushd %{buildroot}%{install_loc}/eclipse
# provided by eclipse-wtp-common
rm -rf features/org.eclipse.wst.common_core.feature_*
rm -rf features/org.eclipse.wst.common_ui.feature_*
rm -f plugins/org.eclipse.jem.util_*.jar
rm -f plugins/org.eclipse.wst.common.ui_*.jar
rm -f plugins/org.eclipse.wst.common.emf_*.jar
rm -f plugins/org.eclipse.wst.validation_*.jar
rm -f plugins/org.eclipse.wst.common.core_*.jar
rm -f plugins/org.eclipse.wst.validation.ui_*.jar
rm -f plugins/org.eclipse.wst.common.infopop_*.jar
rm -f plugins/org.eclipse.wst.internet.cache_*.jar
rm -f plugins/org.eclipse.wst.common.snippets_*.jar
rm -f plugins/org.eclipse.wst.common.frameworks_*.jar
rm -f plugins/org.eclipse.wst.common.modulecore_*.jar
rm -f plugins/org.eclipse.wst.common.uriresolver_*.jar
rm -f plugins/org.eclipse.wst.common.environment_*.jar
rm -f plugins/org.eclipse.wst.validation.infopop_*.jar
rm -f plugins/org.eclipse.wst.common.modulecore.ui_*.jar
rm -f plugins/org.eclipse.wst.common.frameworks.ui_*.jar
rm -f plugins/org.eclipse.wst.common.emfworkbench.integration_*.jar

#provided by eclipse-wtp-sourceediting
rm -rf features/org.eclipse.wst.xml_core.feature_*
rm -rf features/org.eclipse.wst.xml_ui.feature_*
rm -rf features/org.eclipse.wst.xml_userdoc.feature_*
rm -f plugins/org.eclipse.wst.xsd.ui_*.jar
rm -f plugins/org.eclipse.wst.dtd.ui_*.jar
rm -f plugins/org.eclipse.wst.sse.ui_*.jar
rm -f plugins/org.eclipse.wst.xml.ui_*.jar
rm -f plugins/org.eclipse.wst.dtd.core_*.jar
rm -f plugins/org.eclipse.wst.xsd.core_*.jar
rm -f plugins/org.eclipse.wst.sse.core_*.jar
rm -f plugins/org.eclipse.wst.xml.core_*.jar
rm -f plugins/org.eclipse.wst.validation_*.jar
rm -f plugins/org.eclipse.wst.sse.doc.user_*.jar
rm -f plugins/org.eclipse.wst.validation.ui_*.jar
rm -f plugins/org.eclipse.wst.sse.ui.infopop_*.jar
rm -f plugins/org.eclipse.wst.xml.ui.infopop_*.jar
rm -f plugins/org.eclipse.wst.dtd.ui.infopop_*.jar
rm -f plugins/org.eclipse.wst.internet.cache_*.jar
rm -f plugins/org.eclipse.wst.standard.schemas_*.jar
rm -f plugins/org.eclipse.wst.validation.infopop_*.jar
rm -f plugins/org.eclipse.wst.xmleditor.doc.user_*.jar
rm -f plugins/org.eclipse.wst.xsdeditor.doc.user_*.jar
rm -f plugins/org.eclipse.wst.dtdeditor.doc.user_*.jar

popd

%files
%{install_loc}
%doc org.eclipse.wst.ws.api.doc/about.html
%doc epl-v10.html

%changelog
* Sun Nov 11 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-5
- Readd wrapper bundles for axis, jaxrpc, apache-commons-discovery: RHBZ 872806
- Add emf-sdk as BR/R because of some missing bundles.
- Remove problematic org.eclipse.license stuff.
- Fix OSGi imported version of org.w3c.dom* in org.eclipse.wst.wsdl.validation

* Sat Jul 21 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-4
- Add patch to build bundle org.eclipse.jst.ws.annotations

* Sat Jul 21 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-3
- Remove duplicate features as well as plugins from other wtp packages

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jul 12 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-1
- Update to 3.4.0 release.
- add symlinks to additional orbit deps

* Wed Jun 27 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.6.20120617cvs
- Remove duplicate jars from other plugins
- remove org.apache.axis clunky bundle, now that axis is fixed
- add min. versions for dependencies; make patch names consistent

* Sat Jun 16 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.5.20120617cvs
- Remove additional duplicate jars and recreate their symlinks
- Add eclipse-swt and geronimo-osgi-support as dependencies
- Build org.apache.axis bundle - needed for wtp-jeetools

* Fri Jun 15 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.4.20120602cvs
- Build org.eclipse.wst.ws_ui.feature, which will in turn build the others

* Thu Jun 14 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.3.20120602cvs
- Include license.html as a doc, add additional Requires/BuildRequires

* Wed Jun 13 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.2.20120602cvs
- Reorder the prep section to delete prebuild stuff first

* Sat Jun 02 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.1.20120602cvs
- Initial Fedora package
